'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _colors = require('colors');

var _colors2 = _interopRequireDefault(_colors);

var _Command2 = require('./Command');

var _Command3 = _interopRequireDefault(_Command2);

var _yahooFinance = require('yahoo-finance');

var _yahooFinance2 = _interopRequireDefault(_yahooFinance);

var _libStringHelper = require('../lib/stringHelper');

var _libStringHelper2 = _interopRequireDefault(_libStringHelper);

var _libTableHelper = require('../lib/tableHelper');

var _libTableHelper2 = _interopRequireDefault(_libTableHelper);

var _libSnapshotFieldFormatter = require('../lib/snapshotFieldFormatter');

var _libSnapshotFieldFormatter2 = _interopRequireDefault(_libSnapshotFieldFormatter);

var Column = _libTableHelper2['default'].Column;
var tableHelper = _libTableHelper2['default'].tableHelper;

var SnapshotCommand = (function (_Command) {
    _inherits(SnapshotCommand, _Command);

    function SnapshotCommand() {
        _classCallCheck(this, SnapshotCommand);

        _get(Object.getPrototypeOf(SnapshotCommand.prototype), 'constructor', this).apply(this, arguments);
    }

    _createClass(SnapshotCommand, [{
        key: 'setup',
        value: function setup(vorpal) {
            vorpal.command('snapshot <symbol>', 'Displays the current snapshot of the given symbol').option('-f, --fields <fields>', 'Fields that should be displayed').alias('s').action(function (args, callback) {

                var _this = this;
                var fields = ['s', 'n', 'd1', 't1', 'l1'];
                if (args.options.fields) {
                    fields = args.options.fields.split(',');
                }
                var symbols = args.symbol.split(',');

                try {
                    _yahooFinance2['default'].snapshot({
                        symbols: symbols,
                        fields: fields
                    }, function (err, snapshot) {
                        if (err) {
                            _this.log(_colors2['default'].red('error: ' + err));
                            callback();
                        } else {
                            (function () {

                                // Columns
                                var columns = [new Column('field', 30, 'white', ' ', false)];
                                for (var i = 0; i < snapshot.length; i++) {
                                    columns.push(new Column(symbols[i], 40, 'green'));
                                }

                                // Data
                                var data = [];
                                var defaultSnapshot = snapshot[0];
                                var snapshotFields = Object.keys(defaultSnapshot);

                                snapshotFields.forEach(function (f) {
                                    var rowData = [f];
                                    for (var i = 0; i < snapshot.length; i++) {
                                        rowData.push(_libSnapshotFieldFormatter2['default'].formatValue(f, snapshot[i][f]));
                                    }
                                    data.push(rowData);
                                });

                                _this.log(tableHelper.createTable(columns, data));

                                callback();
                            })();
                        }
                    });
                } catch (ex) {
                    _this.log(_colors2['default'].red('error: ' + ex));
                }
            });
        }
    }]);

    return SnapshotCommand;
})(_Command3['default']);

exports['default'] = new SnapshotCommand();
module.exports = exports['default'];