'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _colors = require('colors');

var _colors2 = _interopRequireDefault(_colors);

var _Command2 = require('./Command');

var _Command3 = _interopRequireDefault(_Command2);

var _yahooFinance = require('yahoo-finance');

var _yahooFinance2 = _interopRequireDefault(_yahooFinance);

var _libStringHelper = require('../lib/stringHelper');

var _libStringHelper2 = _interopRequireDefault(_libStringHelper);

var _libTableHelper = require('../lib/tableHelper');

var _libTableHelper2 = _interopRequireDefault(_libTableHelper);

var _babar = require('babar');

var _babar2 = _interopRequireDefault(_babar);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _formato = require('formato');

var _formato2 = _interopRequireDefault(_formato);

var Column = _libTableHelper2['default'].Column;
var tableHelper = _libTableHelper2['default'].tableHelper;

var SnapshotCommand = (function (_Command) {
    _inherits(SnapshotCommand, _Command);

    function SnapshotCommand() {
        _classCallCheck(this, SnapshotCommand);

        _get(Object.getPrototypeOf(SnapshotCommand.prototype), 'constructor', this).apply(this, arguments);
    }

    _createClass(SnapshotCommand, [{
        key: 'setup',
        value: function setup(vorpal) {
            vorpal.command('variation <symbol>', 'Displays the current snapshot of the given symbols').option('-f, --from <from>', 'Start date').option('-t, --to <to>', 'Start date').option('-l, --lastDays <lastDays>', 'Start date').alias('v').action(function (args, callback) {
                var _this = this;

                try {

                    var from = undefined;
                    var to = undefined;

                    // setting time window
                    if (args.options.lastDays) {
                        from = (0, _moment2['default'])().subtract(args.options.lastDays, 'day').format("YYYY-MM-DD");
                        to = (0, _moment2['default'])().format("YYYY-MM-DD");
                    } else if (args.options.from && args.options.to) {
                        from = args.options.from;
                        to = args.options.to;
                    } else {
                        from = (0, _moment2['default'])().subtract(10, 'day').format("YYYY-MM-DD");
                        to = (0, _moment2['default'])().format("YYYY-MM-DD");
                    }

                    _yahooFinance2['default'].historical({
                        symbol: args.symbol,
                        from: from,
                        to: to
                    }, function (err, snapshot) {
                        if (err) {
                            _this.log(_colors2['default'].red('error: ' + err));
                            callback();
                        } else {

                            try {

                                // process values
                                var valueStart = snapshot[0].open;
                                var valueStartDate = (0, _moment2['default'])(snapshot[0].date).format('YYYY-MM-DD');
                                var valueEnd = snapshot[snapshot.length - 1].close;
                                var valueEndDate = (0, _moment2['default'])(snapshot[snapshot.length - 1].date).format('YYYY-MM-DD');

                                var variation = valueEnd - valueStart;
                                var variationPercentual = 100 * variation / valueStart;
                                var lowest = _underscore2['default'].min(snapshot, function (o) {
                                    return o.low;
                                }).low;
                                var highest = _underscore2['default'].max(snapshot, function (o) {
                                    return o.high;
                                }).high;
                                var loHiDifference = highest - lowest;

                                // Columns
                                var columns = [new Column('field', 30, 'yellow', ' ', false), new Column('description', 30, 'white', ' ', false)];

                                var data = [];
                                data.push(['open value (' + valueStartDate + ')', _formato2['default'].format(valueStart)]);
                                data.push(['close value (' + valueEndDate + ')', _formato2['default'].format(valueEnd)]);
                                data.push(['variation', _formato2['default'].format(variation)]);
                                data.push(['variation (%)', _formato2['default'].format(variationPercentual) + '%']);
                                data.push(['lowest value', _formato2['default'].format(lowest)]);
                                data.push(['highest value', _formato2['default'].format(highest)]);
                                data.push(['lo/hi difference', _formato2['default'].format(loHiDifference)]);

                                _this.log(tableHelper.createTable(columns, data));

                                callback();
                            } catch (ex) {
                                _this.log(_colors2['default'].red('Could not process your request. Please check the parameters. Make sure the symbol you are looking for really exists.'));
                                callback();
                            }
                        }
                    });
                } catch (ex) {
                    _this.log(_colors2['default'].red('error: ' + ex));
                    callback();
                }
            });
        }
    }]);

    return SnapshotCommand;
})(_Command3['default']);

exports['default'] = new SnapshotCommand();
module.exports = exports['default'];