'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _formato = require('formato');

var _formato2 = _interopRequireDefault(_formato);

/**
 * Formatter for snapshot field values
 */

var SnapshotFieldFormatter = (function () {
    function SnapshotFieldFormatter() {
        _classCallCheck(this, SnapshotFieldFormatter);

        this.formatters = new Object();
    }

    _createClass(SnapshotFieldFormatter, [{
        key: 'registerFormatter',

        /**
         * Registers a formatter function for the given fieldName
         * @param fieldName
         * @param formatter
         */
        value: function registerFormatter(fieldName, formatter) {
            this.formatters[fieldName] = formatter;
        }

        /**
         * Formats the value for the given fieldName
         * @param fieldName
         * @param value
         * @returns {*}
         */
    }, {
        key: 'formatValue',
        value: function formatValue(fieldName, value) {
            if (this.formatters.hasOwnProperty(fieldName)) {
                return this.formatters[fieldName](value);
            }
            return value;
        }
    }]);

    return SnapshotFieldFormatter;
})();

var snapshotFieldFormatter = new SnapshotFieldFormatter();

// registers the default formatters
snapshotFieldFormatter.registerFormatter('lastTradeDate', function (val) {
    if (!val) {
        return val;
    }
    return (0, _moment2['default'])(val).format('YYYY-MM-DD');
});
snapshotFieldFormatter.registerFormatter('volume', function (val) {
    return _formato2['default'].format(val, { precision: 0 });
});

exports['default'] = snapshotFieldFormatter;
module.exports = exports['default'];